; File:         Char1_1.asm
; Author:       RuiLoureiro
; Date:         20 /06 /2005
; Assembled in Quick Editor in Project -> Console Assemble & Link
; 
.486 
.model flat,stdcall 
option casemap:none 
include \masm32\include\windows.inc
;**********************************************************************************************
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc 
include \masm32\include\msvcrt.inc 

include \masm32\include\masm32.inc
; ---------------------------------------------------------------------------------------------
includelib \masm32\lib\kernel32.lib 
includelib \masm32\lib\user32.lib
includelib \masm32\lib\msvcrt.lib 
includelib \masm32\lib\masm32.lib

include \masm32\macros\macros.asm
include \masm32\macros\ucmacros.asm
;-------------------------------------------------------------------------------------------
.data
align 4
                  dd ?                 ; -8 number of records read
                  dd 20                ; -4 number of record structures
_InputBuffer      db 20*20 dup (?)
; 
       dd 23
WSTR  _UniString1, " j s ngremes aces"  ; testar acentos
       dd 32
WSTR  _UniString2, "  j s ngremes ACES  "  ; testar acentos
; ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
.data?
_hScreenBuffer    dd ?
_hInputBuffer     dd ?
;----------------------------------------------------------------------------------------------
.code 
; 
start:           call     HndInOutGet    
                 jc       _eStart

                 mov       edx, offset _UniString1 
                 mov       ecx, dword ptr [edx - 4]
                 call      BufferPrint
                 call      wait_key                          
                 
                 mov       edx, offset _UniString2
                 mov       ecx, dword ptr [edx - 4]
                 call      BufferPrint
                 call      wait_key
                 ;
                 ; close all
                 ; ---------
_sbStart:	     invoke	  CloseHandle, _hScreenBuffer          ; Close screen buffer
                 invoke   CloseHandle, _hInputBuffer           ; Close input buffer
                 
_eStart:         invoke	  ExitProcess, 0
; ==============================================
;                    *****         PROCEDURES          *****
; 
HndInOutGet       proc  
                  invoke   GetStdHandle, STD_INPUT_HANDLE     
	            cmp      eax, INVALID_HANDLE_VALUE
                  jne      short @F
                  ;
                  stc
                  ret	
                  ;
                  ; This is the SCREEN number 0
                  ; ---------------------------
@@:               mov      _hInputBuffer, eax                     ; input buffer handle
                  ;
                  invoke   GetStdHandle, STD_OUTPUT_HANDLE    
	            cmp      eax, INVALID_HANDLE_VALUE
                  jne      short @F
                  ;
                  invoke   CloseHandle, _hInputBuffer             ; Close input buffer
                  stc
                  ret
                  ; ----------------------
                  ; Get screen buffer info
                  ; ----------------------
@@:               mov      _hScreenBuffer, eax                    ; screen buffer handle
                  clc
                  ret
HndInOutGet       endp                 
; 
; Action:
;        Prints the buffer pointed by EDX.
;
; Input:
;        EDX   - Buffer string pointer
;        ECX   - buffer's length
;
BufferPrint         proc    
                    LOCAL   wNum:DWORD
                    pushad
                    ;
                    or       ecx, ecx
                    jz       short @F
                    
                    push     ecx
                        lea      ebx, wNum
                        invoke   WriteConsoleW, _hScreenBuffer,       ; handle
                                                edx,                  ; print buffer
                                                ecx,                  ; write ECX char
                                                ebx,                  ; Number written
                                                0                     ;
                    pop     ecx
                    ;
                    cmp     eax, 0
                    jne     short @F
                    ;
                    lea     ebx, wNum
                    cmp     ecx, dword ptr [ebx]
                    je      short @F
                    
                    stc
                    popad
                    ret

@@:                 clc
                    popad
                    ret
BufferPrint         endp
; 
wait_key            proc
                    invoke FlushConsoleInputBuffer, _hInputBuffer

@@:                 call   crt__kbhit
                    test   eax, eax
                    jz     @B
                    ret
wait_key            endp
; 
END start

